//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//     PV_6501.DLL
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop


#include "pv6501.h"
#include "main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

TForm1 *Form1;
OSC   oscreg;                   //   
GEN   genreg;                   //   
UCHAR oscdata[MAX_BUF_LENGTH];  //    
UCHAR trigdata[MAX_BUF_LENGTH]; //    

//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
void __fastcall TForm1::btnOpenClick(TObject *Sender)
{
  char res = pv_Open();
  AnsiString str;
  str = "Open: ";
  if (!res) str += "Ok."; else str += "Error.";
  LineAdd(str);

}
//---------------------------------------------------------------------------
//        
//---------------------------------------------------------------------------
void __fastcall TForm1::Memo1DblClick(TObject *Sender)
{
  Memo1->Clear();
}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Memo1->Clear();
}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void __fastcall TForm1::btnPutOSCClick(TObject *Sender)
{
//----------------------------------------------
//    
//----------------------------------------------
  oscreg.adc_mode =
   ((CheckBox1->Checked << bit_ExtTrigSig)|
    (CheckBox2->Checked << bit_NegSinc)|
    (CheckBox3->Checked << bit_ExtSinc)|
    (CheckBox4->Checked << bit_PeakDetOff)|
    (CheckBox5->Checked << bit_AutoRestart)|
    (CheckBox6->Checked << bit_AutoSync));
//----------------------------------------------
  oscreg.smpl_per  = (ULONG)CSpinEdit1->Value;
//----------------------------------------------
  oscreg.smpl_pre  = (UINT) CSpinEdit2->Value;
//----------------------------------------------
  oscreg.smpl_post = (UINT) CSpinEdit3->Value;
//----------------------------------------------
  oscreg.zerolevel = (UINT) CSpinEdit4->Value;
//----------------------------------------------
  oscreg.trig_lev  = (UCHAR)CSpinEdit5->Value;
  oscreg.trig_gist = (UCHAR)CSpinEdit6->Value;
//----------------------------------------------
  oscreg.trig_numb = (UCHAR)CSpinEdit7->Value;
//----------------------------------------------
  UCHAR fin;
  if (RadioButton1->Checked) fin = fmetr_In0; else
  if (RadioButton2->Checked) fin = fmetr_In1; else
  if (RadioButton3->Checked) fin = fmetr_In2;

  oscreg.fmetr_in  = fin;
//----------------------------------------------
  UCHAR atttbl[] = {att_005VDiv, att_01VDiv, att_02VDiv,
                    att_05VDiv, att_1VDiv,  att_2VDiv};

  oscreg.att       =  atttbl[ComboBox1->ItemIndex];
//----------------------------------------------
  oscreg.close_in  =  CheckBox7->Checked;
  oscreg.gen_off   =  CheckBox8->Checked;
//----------------------------------------------
// 
//----------------------------------------------
  char res = pv_PutOscReg(&oscreg);
  CSpinEdit2->Value = oscreg.smpl_pre; //   . 

//----------------------------------------------
//     
//----------------------------------------------
  AnsiString str = "PutOscReg: ";
  if (!res) str += "Ok."; else str += "Error.";
  LineAdd(str);
}
//---------------------------------------------------------------------------
//   OSC   5-   
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGetOSCClick(TObject *Sender)
{
//----------------------------------------------
//  
//----------------------------------------------
  char res = pv_GetOscReg(&oscreg);
//----------------------------------------------
//  
//----------------------------------------------
  AnsiString str = "GetOscReg: ";
  if (!res) str += "Ok."; else str += "Error.";
  LineAdd(str);
  if (res) return;
//----------------------------------------------
//  
//----------------------------------------------
  LineAdd("adc_mode:"+IntToHex(oscreg.adc_mode, 2));
  LineAdd("smpl_per:"+IntToStr((__int64)oscreg.smpl_per));
  LineAdd("smpl_pre:"+IntToStr((__int64)oscreg.smpl_pre));
  LineAdd("smpl_post:"+IntToStr((__int64)oscreg.smpl_post));
  LineAdd("pwm:      "+IntToStr((int)oscreg.zerolevel));
  Label8->Caption = "F = " + CurrToStr(oscreg.freq);
}
//---------------------------------------------------------------------------
//    ,  5-    
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGetOscDataClick(TObject *Sender)
{
//----------------------------------------------
//  
//----------------------------------------------
  char res = pv_GetData(oscdata,NULL, &oscreg);
//----------------------------------------------
//  
//----------------------------------------------
  AnsiString str = "GetOscReg: ";
  if (!res) str += "Ok.";
  else
  {
    str += "Error.";
    LineAdd(str);
    return;
  }
  LineAdd(str);
//----------------------------------------------
//  
//----------------------------------------------
  LineAdd("adc_mode:"+IntToHex(oscreg.adc_mode, 2));
  LineAdd("smpl_per:"+IntToHex((__int64)oscreg.smpl_per, 5));
  LineAdd("smpl_pre:"+IntToHex((__int64)oscreg.smpl_pre, 4));
  LineAdd("smpl_post:"+IntToHex((__int64)oscreg.smpl_post, 4));
  LineAdd("pwm:      "+IntToHex((int)oscreg.zerolevel, 3));
  Label8->Caption = "F = " + CurrToStr(oscreg.freq);
//----------------------------------------------
//  ,   
//----------------------------------------------
  AddHex(oscdata, oscreg.smpl_pre+oscreg.smpl_post);
  GrClear();
  PutWaveform(oscdata, oscreg.smpl_pre+oscreg.smpl_post , (TColor)0x00FF00,0,0);
  PutFreq(&oscreg);

}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void __fastcall TForm1::btnPutGenClick(TObject *Sender)
{
//----------------------------------------------
//    
//----------------------------------------------
  genreg.waveform = ComboBox2->ItemIndex;
  genreg.mode     = ComboBox3->ItemIndex;
  genreg.freq     = CSpinEdit8->Value;
  genreg.end_freq = CSpinEdit11->Value;
  genreg.f_mod    = CSpinEdit12->Value;
  genreg.k        = CSpinEdit9->Value;
  genreg.ampl     = CSpinEdit10->Value;
//----------------------------------------------
// 
//----------------------------------------------
  char res = pv_PutGenReg(&genreg);
//----------------------------------------------
//  
//----------------------------------------------
  AnsiString str = "PutGenReg: ";
  if (!res)
  {
    //  Sweep       !!!
    if (genreg.mode == genmode_Sweep)
    CSpinEdit11->Value = genreg.end_freq;
    str += "Ok.";
  }
  else str += "Error.";

  LineAdd(str);
}

//---------------------------------------------------------------------------
//    -     
//    
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{

 char res = pv_GetData(oscdata,trigdata, &oscreg);
 if (res) return;

//   
//---------------------------------------------------------------------------
 UINT smlen = oscreg.smpl_pre + oscreg.smpl_post;  // 
 if (!smlen) return;
 UINT mark  = 0;                //   

 bool eq_end  = (oscreg.addr_eq>>15)&1;  // 
 bool eq_flag = (oscreg.addr_eq>>14)&1;  // 
//---------------------------------------------------------------------------
 if ((oscreg.adc_mode >> bit_AutoRestart)&1)// 
 {
   mark = oscreg.addr_eq & 0x3FFF;    // 
   //     
   if (eq_flag == 0) mark = smlen;
   if ((eq_flag == 1)&&(eq_end == 0))
       setmem (oscdata + mark, smlen - mark, 0); //    
 }

//  
 for (UINT i=0;i<(smlen);i++) *(trigdata + i) *= 50;

 GrClear(); // 
 //     
 if ((oscreg.adc_mode >> bit_ExtTrigSig)&1)
   PutWaveform(trigdata, smlen , (TColor)0xFF0000,0,0);
 //  
 PutWaveform(oscdata, smlen , (TColor)0x00FF00,mark,
              !((oscreg.adc_mode>>bit_PeakDetOff)&1));
   // 
 PutFreq(&oscreg);
}
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
void __fastcall TForm1::btnTimerClick(TObject *Sender)
{
  if (Timer1->Enabled)
 {
   btnTimer->Caption = "Timer on";
   Timer1->Enabled = false;
 }
 else
 {
   btnTimer->Caption = "Timer off";
   Timer1->Enabled = true;
 }
}
//---------------------------------------------------------------------------
//  HEX 
//---------------------------------------------------------------------------
void __fastcall TForm1::AddHex(PUCHAR buf, UINT len)
{
  for(UINT i = 0; i < len;)
  {
    UCHAR j = 16;
    AnsiString str = "";
    while ((j--)&&(i < len))
    {
      str += IntToHex(*(buf+i),2) + " ";
      i++;
    }
    LineAdd(str);
  }
}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void __fastcall TForm1::PutWaveform(PUCHAR buf, UINT len, TColor color,
                                    UINT mark, bool minmax)
{
  PaintBox1->Canvas->Pen->Color = color;              //
  if (minmax)
  {
   len  /= 2; // . .    
   mark /= 2; //    
  }

  float step = (float)PaintBox1->Width / (float)len;  //   

  int Height = PaintBox1->Height;
  float x = 0;
  PaintBox1->Canvas->MoveTo(0,Height -1 - (*buf)/2);     //  
  //  
  for (UINT i = 0;(i<len);i++)
  {
    if (minmax)
    {
      PaintBox1->Canvas->MoveTo((int)x,Height - 1 - (*buf)/2); // 
      buf++;
    }

    PaintBox1->Canvas->LineTo((int)x,Height - 1 - (*buf)/2);
    if ((mark) && (i == mark))    //   
    {
      PaintBox1->Canvas->Pen->Color = clRed; //  ""
      //     
      PaintBox1->Canvas->MoveTo(int(x),0);
      PaintBox1->Canvas->LineTo(int(x),PaintBox1->Height);
      PaintBox1->Canvas->MoveTo(x, Height - 1 - (*buf)/2);
    }
    buf++;
    x += step;
  }
}
//---------------------------------------------------------------------------
//  
//---------------------------------------------------------------------------
void TForm1::PutFreq(POSC oscreg)
{
   if (oscreg->f_valid) //  
     Label8->Caption = "F = " + FloatToStr(oscreg->freq);
   else Label8->Caption = "F = ...";
}
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
void __fastcall TForm1::LineAdd(AnsiString str)
{
   Memo1->Lines->Add(str);
}
void __fastcall TForm1::btnCloseClick(TObject *Sender)
{
  char res = pv_Close();
  AnsiString str;
  str = "Close: ";
  if (!res) str += "Ok."; else str += "Error.";
  LineAdd(str);
}

//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGetGenClick(TObject *Sender)
{
  pv_GetGenReg(&genreg);
  LineAdd("waveform:"+IntToHex(genreg.waveform,1));
  LineAdd("mode:"+IntToHex(genreg.mode,1));
  LineAdd("freq:"+IntToStr((__int64)genreg.freq));
  LineAdd("end_freq:"+IntToStr((__int64)genreg.end_freq));
  LineAdd("f_mod:"+IntToStr((__int64)genreg.f_mod));
  LineAdd("k:"+IntToStr((__int64)genreg.k));
  LineAdd("ampl:"+IntToStr((__int64)genreg.ampl));

}
//---------------------------------------------------------------------------
//      pv_GetAllReg
//  adc_mode  gen_mode:
//---------------------------------------------------------------------------
void __fastcall TForm1::btnGetAllClick(TObject *Sender)
{
  pv_GetAllReg(&oscreg,&genreg);
  LineAdd("adc_mode:"+IntToStr(oscreg.adc_mode));
  LineAdd("gen_mode:"+IntToHex(genreg.mode,1));
}
//---------------------------------------------------------------------------
//   
//---------------------------------------------------------------------------
void __fastcall TForm1::GrClear(void)
{
  //     
  PaintBox1->Canvas->Brush->Color = clWhite;
  TRect rect;
  rect = Rect(Point(0, 0), Point(PaintBox1->Width, PaintBox1->Height));
  PaintBox1->Canvas->FillRect(rect);
}

//---------------------------------------------------------------------------
//       
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox3Select(TObject *Sender)
{
  CSpinEdit11->Enabled = false;   //  
  Label11->Enabled     = false;
  CSpinEdit12->Enabled = false;   // 
  CSpinEdit12->MinValue = 0;
  Label13->Enabled     = false;
  CSpinEdit9->Enabled  = false;   // 
  Label10->Enabled     = false;
  Label13->Caption = "  (10)";
  Label10->Caption = "  (0.1%)";
  CSpinEdit9->MaxValue = 2000;
  Label9->Caption     = " (0.1)";
  CSpinEdit8->MaxValue  = 100000000;
  CSpinEdit8->MinValue  = 0;
  ComboBox2->Enabled   = true;

  switch (ComboBox3->ItemIndex)
  {
  case genmode_FM:
    Label10->Caption = "  (10)";
    Label13->Caption = "  (10)";
    CSpinEdit12->Enabled = true;   // 
    Label13->Enabled     = true;
    CSpinEdit9->Enabled  = true;   // 
    Label10->Enabled     = true;
    CSpinEdit12->MaxValue = 10000;
    break;
  case genmode_AM:
    CSpinEdit12->Enabled = true;   // 
    Label13->Enabled     = true;
    CSpinEdit9->Enabled  = true;   // 
    Label10->Enabled     = true;
    break;
  case genmode_Pulse:
    CSpinEdit12->Enabled  = true;
    CSpinEdit12->MaxValue = 134217727;
    CSpinEdit12->MinValue = 1;
    Label13->Enabled      = true;
    Label13->Caption      = "  (10ns)";
    Label9->Caption       = "  (10ns)";
    CSpinEdit8->MaxValue  = 134217727;
    ComboBox2->Enabled    = false;
    CSpinEdit8->MinValue  = 3;
    break;
  case genmode_Sweep:
    CSpinEdit11->Enabled = true;   //  
    Label11->Enabled     = true;
    break;
  }
}
//---------------------------------------------------------------------------
//    
//---------------------------------------------------------------------------
void __fastcall TForm1::CSpinEdit5Change(TObject *Sender)
{
  if ((255 - CSpinEdit5->Value)<CSpinEdit5->Value)
    CSpinEdit6->MaxValue = (255 - CSpinEdit5->Value) * 2;
  else
    CSpinEdit6->MaxValue = CSpinEdit5->Value * 2;

  if(CSpinEdit6->Value > CSpinEdit6->MaxValue)
    CSpinEdit6->Value = CSpinEdit6->MaxValue;
}
//---------------------------------------------------------------------------




