#ifdef __DLL
#define _DECLSPEC __declspec(dllexport)
#endif
#ifndef __DLL
#define _DECLSPEC __declspec(dllimport)
#endif

#define MAX_BUF_LENGTH 0x4000

//************************************************************
//------------------------------------------------------------
//    
//------------------------------------------------------------
typedef struct _OSC
{
  UCHAR adc_mode;
  ULONG smpl_per;
  UINT  smpl_pre;
  UINT  smpl_post;
  UINT  zerolevel;
  UCHAR trig_lev;
  UCHAR trig_gist;
  UCHAR trig_numb;
  UCHAR fmetr_in;
  UCHAR att;
  bool close_in;
  bool gen_off;
  double freq;
  bool f_valid;
  UINT addr_eq;
  UCHAR ext_trig_dly;

} OSC, *POSC;
//------------------------------------------------------------
//  UCHAR adc_mode;
    #define bit_ExtTrigSig    0
    #define bit_NegSinc       1
    #define bit_ExtSinc       2
    #define bit_PeakDetOff    3
    #define bit_AutoRestart   4
    #define bit_AutoSync      5
// bit 0 = 1 -      
// bit 1 = 1 -   
// bit 2 = 1 -  
// bit 3 = 1 -    ( min max)
// bit 4 = 1 -  restart (.   .)
// bit 5 = 1 -    
//------------------------------------------------------------
//  ULONG smpl_per;
//     10ns  (24 )
//------------------------------------------------------------
//  UINT  smpl_pre;
//  UINT  smpl_post;
//          (13 )
//------------------------------------------------------------
//  UINT  pwm;
//     (12 )
//------------------------------------------------------------
//  UCHAR trig_lev;
//  UCHAR trig_gist;
//      (8 )
//------------------------------------------------------------
//  UCHAR trig_numb;
//      0 - 
//------------------------------------------------------------
//  UCHAR fmetr_in;
//    
//  0 -    
//  1 -   . . (.  100 )
//  2 -   . .   .   8
//  3 = 2
    #define fmetr_In0         0
    #define fmetr_In1         1
    #define fmetr_In2         2
    #define fmetr_In3         3
//------------------------------------------------------------
//  UCHAR att;
//    
    #define att_2VDiv       3  /* 011 */
    #define att_1VDiv       7  /* 111 */
    #define att_05VDiv      6  /* 110 */
    #define att_02VDiv      4  /* 100 */
    #define att_01VDiv      1  /* 001 */
    #define att_005VDiv     0  /* 000 */
//------------------------------------------------------------
//  bool close_in;
//  1 -  
//  0 -  
//------------------------------------------------------------
//  bool gen_off;
//       
//------------------------------------------------------------
//  double freq;
//   
//------------------------------------------------------------
//  bool f_valid;
//    
//------------------------------------------------------------
//  UINT addr_eq;
//
//------------------------------------------------------------
//  UCHAR ext_trig_dly;
//     . .  5 
// 1 = ~500 pS
//************************************************************
//------------------------------------------------------------
//    
//------------------------------------------------------------
typedef struct _GEN
{
  UCHAR  waveform;
  UCHAR  mode;
  ULONG  freq;
  ULONG  end_freq;
  DWORD  f_mod;
  UINT   k;
  UINT   ampl;
} GEN, *PGEN;
//------------------------------------------------------------
//  UCHAR  waveform;
//  
#define wavform_Sin         0
#define wavform_Up_Trian    1
#define wavform_Dn_Trian    2
#define wavform_Rect        3
#define wavform_Trian       4
#define wavform_DC          5
//------------------------------------------------------------
//  UCHAR  mode;
//  
#define genmode_Norm        0
#define genmode_Sweep       1
#define genmode_Pulse       2
#define genmode_FM          3
#define genmode_AM          4
//------------------------------------------------------------
//  ULONG  freq;
//    0.1  (0 - 10)
//   genmode_Pulse     10ns (27 )
//   genmode_Sweep  
//------------------------------------------------------------
//  ULONG  end_freq;
//    genmode_Sweep  
//------------------------------------------------------------
//  DWORD  f_mod;
//      10 (0 - 100)
//    genmode_Pulse     10ns (27 )
//------------------------------------------------------------
//  UINT   k;
//    genmode_AM    0.1%
//    genmode_FM    10 (0 - 100)
//------------------------------------------------------------
//  UINT   ampl;
//    0 - 4088 mV (10 )


//************************************************************
//************************************************************
//************************************************************
  //  :
  // 1 - 
  // 0 -  

  //     
extern "C"  char _DECLSPEC __stdcall pv_Open(void);

  //  
extern "C"  char _DECLSPEC __stdcall pv_Close(void);

  //   OSC
extern "C"  char _DECLSPEC __stdcall pv_GetOscReg(POSC oscreg);
  //    OSC
extern "C"  char _DECLSPEC __stdcall pv_PutOscReg(POSC oscreg);

  //   GEN
extern "C"  char _DECLSPEC __stdcall pv_GetGenReg(PGEN);
  //    GEN
extern "C"  char _DECLSPEC __stdcall pv_PutGenReg(PGEN);

  //    OSC  GEN
extern "C"  char _DECLSPEC __stdcall pv_PutAllReg (POSC osc, PGEN gen);
  //     OSC  GEN
extern "C"  char _DECLSPEC __stdcall pv_GetAllReg (POSC osc, PGEN gen);

  //    
  // PCHAR osc_data      MAX_BUF_LENGTH 
  //    
  // PCHAR trig_data      MAX_BUF_LENGTH 
  //     
extern "C"  char _DECLSPEC __stdcall pv_GetData (PCHAR osc_data, PCHAR trig_data, POSC osc);


//      LabVIEW, MatLab...
//  
extern "C"  char _DECLSPEC __stdcall pv_CnfgGenNormal (PGEN genreg,UCHAR wavform,
                                             ULONG freq, UINT ampl);

extern "C"  char _DECLSPEC __stdcall pv_CnfgGenAM (PGEN genreg,UCHAR wavform,
                                        ULONG freq, ULONG f_mod, UINT k, UINT ampl);

extern "C"  char _DECLSPEC __stdcall pv_CnfgGenFM (PGEN genreg, UCHAR wavform,
                                         ULONG freq, ULONG f_mod, UINT k, UINT ampl);

extern "C"  char _DECLSPEC __stdcall pv_CnfgGenPulse (PGEN genreg, ULONG T, ULONG l, UINT ampl);

extern "C"  char _DECLSPEC __stdcall pv_CnfgGenSweep (PGEN genreg, UCHAR wavform,
                                            ULONG start_f, ULONG *end_f, UINT ampl);

//  
extern "C"  char _DECLSPEC __stdcall pv_CnfgADC (POSC reg, UCHAR adc_mode, DWORD smpl_per,
                                      UINT smpl_pre, UINT smpl_post);

extern "C" char _DECLSPEC __stdcall pv_CnfgTrig (POSC reg, UCHAR trig_lev, UCHAR trig_gist, UCHAR n,
                                        UCHAR fmode);
extern "C" char _DECLSPEC __stdcall pv_CnfgAtt (POSC reg, UCHAR att, bool ac, bool gen);

extern "C"  char _DECLSPEC __stdcall pv_CnfgZero (POSC reg, UINT zerolevel);
// 
extern "C"  char _DECLSPEC __stdcall pv_GetFreq (double *freq);




